---@type Mq
mq = require('mq')

local modrod_name = 'Modulation Shard'

local orb_spell = 'Summon Molten Komatiite Orb'
local orb_item = 'Molten Komatiite Orb'
local paradox_spell = 'Grant Voidfrost Paradox Rk. II'
local paradox_item = 'Summoned: Voidfrost Paradox II'
local modshard_spell = 'Sickle of Umbral Modulation Rk. II'
local modshard_item = 'Sickle of Umbral Modulation'

function SummonSpellItem(spell_name, item_name)
	local myitem = GetItem(item_name)
	if (myitem == nil) then
		MemSpellWait(10, spell_name, 10000)
		mq.TLO.Me.DoTarget()
		mq.delay(100)
		WaitCastSpell(spell_name, 10000)
		PauseForCursor(10000)
		mq.delay(2000)
		DoAutoInv()
	end
end

-- Maintained for backward compatibility
function SummonOrbs()
	SummonSpellItem(orb_spell, orb_item)
end

function SummonParadox()
	SummonSpellItem(paradox_spell, paradox_item)
end

function SummonModShard()
	SummonSpellItem(modshard_spell, modshard_item)
end

function SummonModRods(extra_modrod_warning)
	local modrod = mq.TLO.FindItem(modrod_name)
	if (modrod == nil or IsNull(modrod)) then
		print('SummonModRods not found:' .. modrod_name)
		if extra_modrod_warning then
			mq.cmd('/g modrods in 3 ...')
			mq.delay(2000)
			mq.cmd('/g modrods in 2 ...')
			mq.delay(2000)
			mq.cmd('/g modrods in 1 ...')
			mq.delay(2000)
		end
		mq.cmd('/g modrods inc')
		WaitCastAA(596, 10000)
		PauseForCursor(10000)
		DoAutoInv()
	else
		print('SummonModRods found:' .. modrod.Name())
	end
end

function CastPetAura()
	local spell_name = "Rathe's Strength"
	local target_id = mq.TLO.Target.ID()
	local mypet = mq.TLO.Me.Pet
	if IsNull(mypet) then
		print('CastPetAura: NO PET')
		return
	end
	mypet.DoTarget()
	mq.delay(200)
	local duration = BuffSeconds(mypet, spell_name)
	print(spell_name .. ' duration ' .. duration)
	if duration == 0 then
		MemSpellWait(10, spell_name, 10000)
		print(spell_name .. ' on ' .. mypet.Name())
		WaitForGemReady(spell_name, 10000)
		CastNameWait(spell_name, 10000)
	end
	RetargetId(target_id)
end


function CastPetVelocity()
	local spell_name = "Velocity II"
	local target_id = mq.TLO.Target.ID()
	local mypet = mq.TLO.Me.Pet
	if IsNull(mypet) then
		print('CastPetVelocity: NO PET')
		return
	end
	mypet.DoTarget()
	mq.delay(200)
	local duration = BuffSeconds(mypet, spell_name)
	print(spell_name .. ' duration ' .. duration)
	if duration == 0 then
		PauseForCasting(10000)
		CastAAWait(852, 5000)
	end
	RetargetId(target_id)
end


function CompanionAegis()
	local buffname = "Companion's Aegis VI"
	local target_id = mq.TLO.Target.ID()
	local mypet = mq.TLO.Me.Pet
	if IsNull(mypet) then
		print('CastPetVelocity: NO PET')
		return
	end
	mypet.DoTarget()
	mq.delay(200)
	local duration = BuffSeconds(mypet, buffname)
	print(buffname .. ' duration ' .. duration)
	if duration < 20 then
		-- print(buffname .. ' on ' .. mypet.Name())
		CastAAIfReady(441)
	end
	RetargetId(target_id)
end


function ThaumaturgesUnity()
	local target_id = mq.TLO.Target.ID()
	if not mq.TLO.Me.BuffsPopulated() then
		mq.TLO.Me.DoTarget()
		mq.delay(500)
	end
	-- local wanted_buffs = {'Chaotic Largesse Rk. II', 'Ophiolite Bodyguard Rk. II', 'Relentless Guardian Rk. II'}
	local wanted_buffs = {'Chaotic Largesse Rk. II'}
	for buffname in values(wanted_buffs) do
		local duration = BuffSeconds(mq.TLO.Me, buffname)
		print(buffname .. ' duration ' .. duration)
		if duration < 10 then
			WaitCastAA(1169, 10000)
			break
		end
	end
	RetargetId(target_id)
end

local iceflame_barricade = 'Iceflame Barricade Rk. III'
function BuffMyPet()
	print('BuffMyPet')
	local target_id = mq.TLO.Target.ID()
	local mypet = mq.TLO.Me.Pet
	local wanted_buffs = {'Burnout XV Rk. III', 'Circle of Emberweave Coat'}
	print('IsRaid ' .. SafeInt(mq.TLO.Raid.Members()))
	if IsRaid() == false then
		print('Adding ' .. iceflame_barricade)
		table.insert(wanted_buffs, iceflame_barricade)
	end
	if mypet then
		mypet.DoTarget()
		mq.delay(200)
		for buffname in values(wanted_buffs) do
			local duration = BuffSeconds(mypet, buffname)
			print(buffname .. ' duration ' .. duration)
			if duration < 20 then
				-- MemSpellWait(11, buffname, 5000)
				print(buffname .. ' on ' .. mypet.Name())
				WaitForGemReady(buffname, 10000)
				CastNameWait(buffname, 10000)
			end
		end
		RetargetId(target_id)
	end
end


function BuffMyPetAA()
	-- Companion's Fortification
	CastAAWait(3707, 5000)
	-- Companion's Fury
	CastAAWait(60, 5000)
	-- Second Wind Ward
	CastAAWait(2066, 5000)
end
